/**
 * CGBHandler<br>
 * A class that contains routines to read and add to a data file containing the
 * guestbook entries.
 * <br>
 * You are free to use this code and to make modifications provided
 * this notice is retained.
 * <p>
 * If you found this useful, please add a note of acknowledgement to my guestbook,
 * or send me a mail at <a href="mailto:tanmaykm@hotmail.com">tanmaykm@hotmail.com</a>. 
 * If you would like to report a bug or suggest some improvements, 
 * you are most welcome. I will be happy to help you use this piece of code.
 * <p>
 *
 * @author 	    Tanmay K. Mohapatra
 * @version     1.00, 27th June, 1999
 */

#ifndef GBHANDLER_H
#define GBHANDLER_H

#include "TokenReplacer.h"
#include "DataPair.h"

class CGBHandler
{
private:
    CTokenReplacer  *pTokenReplacer;
    CDataPair       *pDataParser;
    char            **pEntries;
    char            sFileName[1024];
    char            sOneEntry[1024*64];

    int             readEntries(int iNumber, int iLastIndex);
    void            freeEntries(void);

public:
    char ** getTokenList        (void);
    int     getNumToks          (void);
    int     appendEntry         (const char **sFldValues);
    int     prepareHTML         (int iNumber, int iLastIndex, char **pBuffer, int *piLen);
    int     setOutputTemplate   (const char *sTemplateFile);
    int     countEntries        (void);

        CGBHandler              (const char *sFileName);
        ~CGBHandler             ();
};

#endif /* GBHANDLER_H */
