/**
 * CTokenReplacer<br>
 * A class to prepare complete HTML (or any other format) output from a template 
 * containing tokens to be replaced and the values that are to be replaced.
 * <br>
 * You are free to use this code and to make modifications provided
 * this notice is retained.
 * <p>
 * If you found this useful, please add a note of acknowledgement to my guestbook,
 * or send me a mail at <a href="mailto:tanmaykm@hotmail.com">tanmaykm@hotmail.com</a>. 
 * If you would like to report a bug or suggest some improvements, 
 * you are most welcome. I will be happy to help you use this piece of code.
 * <p>
 *
 * @author 	    Tanmay K. Mohapatra
 * @version     1.00, 27th June, 1999
 */

#ifndef TOKENREPLACER_H
#define TOKENREPLACER_H

#define MAX_NUM_TOKENS      50

class CTokenReplacer
{
private:
    char        *sFileContent;
    char        *asTokenList[MAX_NUM_TOKENS];
    char        *asTextList[2*MAX_NUM_TOKENS];
    int         iNumTokens;

    static char *TOKEN_START;
    static char *TOKEN_END;

    void appendAndExpand(char **ppTarget, const char *pAppend, int *piLen);
    void slurpFile(const char *sFileName, char **sBuffer);
    void parseTokens(void);

public:
            CTokenReplacer(const char *sFileName);
            ~CTokenReplacer();
    int     getNumTokens(void);
    char ** getTokenList(void);
    void    prepareHTML(const char **sValueList, char **sReturn, int *piLen);
};

#endif /* TOKENREPLACER_H */
